ExternalInterface subclass: #WindowsUserDLL
	includeFiles: 'windows.h '
	includeDirectories: 'c:\vc\include\ '
	libraryFiles: 'USER32.DLL '
	libraryDirectories: ''
	generateMethods: ''
	beVirtual: false
	optimizationLevel: #full
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'WindowsUserDLLDictionary '
	category: 'Windows-External Applications'!


!WindowsUserDLL methodsFor: 'types'!

HANDLE
	<C: typedef PVOID HANDLE>!

HWND
	<C: typedef HANDLE HWND>!

PVOID
	<C: typedef void * PVOID>! !

!WindowsUserDLL methodsFor: 'procedures'!

GetActiveWindow
	<C: HWND  GetActiveWindow(void)>
	^self externalAccessFailed! !

ExternalInterface subclass: #Win32CommonDialogs
	includeFiles: 'windef.h commdlg.h '
	includeDirectories: 'c:\vc\include '
	libraryFiles: 'COMDLG32.DLL '
	libraryDirectories: ''
	generateMethods: ''
	beVirtual: false
	optimizationLevel: #full
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Win32CommonDialogsDictionary '
	category: 'Windows-External Applications'!


!Win32CommonDialogs methodsFor: 'types'!

BOOL
	<C: typedef int BOOL>!

CHAR
	<C: typedef char CHAR>!

DWORD
	<C: typedef unsigned long DWORD>!

HANDLE
	<C: typedef PVOID HANDLE>!

HINSTANCE
	<C: typedef HANDLE HINSTANCE>!

HWND
	<C: typedef HANDLE HWND>!

LONG
	<C: typedef long LONG>!

LPARAM
	<C: typedef LONG LPARAM>!

LPCSTR
	<C: typedef const CHAR * LPCSTR>!

LPOFNHOOKPROC
	<C: typedef UINT (* LPOFNHOOKPROC)(HWND, UINT, WPARAM, LPARAM)>!

LPOPENFILENAMEA
	<C: typedef struct tagOFNA * LPOPENFILENAMEA>!

LPSTR
	<C: typedef CHAR * LPSTR>!

OPENFILENAMEA
	<C: typedef struct tagOFNA OPENFILENAMEA>!

PVOID
	<C: typedef void * PVOID>!

WORD
	<C: typedef unsigned short WORD>! !

!Win32CommonDialogs methodsFor: 'structs'!

tagOFNA
	<C: struct tagOFNA {
			DWORD lStructSize;
			HWND hwndOwner;
			HINSTANCE hInstance;
			LPCSTR lpstrFilter;
			LPSTR lpstrCustomFilter;
			DWORD nMaxCustFilter, nFilterIndex;
			LPSTR lpstrFile;
			DWORD nMaxFile;
			LPSTR lpstrFileTitle;
			DWORD nMaxFileTitle;
			LPCSTR lpstrInitialDir, lpstrTitle;
			DWORD Flags;
			WORD nFileOffset, nFileExtension;
			LPCSTR lpstrDefExt;
			LPARAM lCustData;
			LPOFNHOOKPROC lpfnHook;
			LPCSTR lpTemplateName;
		}>! !

!Win32CommonDialogs methodsFor: 'defines'!

OFN_ALLOWMULTISELECT
	<C: #define OFN_ALLOWMULTISELECT 0x00000200
	>!

OFN_CREATEPROMPT
	<C: #define OFN_CREATEPROMPT 0x00002000
	>!

OFN_ENABLEHOOK
	<C: #define OFN_ENABLEHOOK 0x00000020
	>!

OFN_ENABLETEMPLATE
	<C: #define OFN_ENABLETEMPLATE 0x00000040
	>!

OFN_ENABLETEMPLATEHANDLE
	<C: #define OFN_ENABLETEMPLATEHANDLE 0x00000080
	>!

OFN_EXPLORER
	<C: #define OFN_EXPLORER 0x00080000
	>!

OFN_EXTENSIONDIFFERENT
	<C: #define OFN_EXTENSIONDIFFERENT 0x00000400
	>!

OFN_FILEMUSTEXIST
	<C: #define OFN_FILEMUSTEXIST 0x00001000
	>!

OFN_HIDEREADONLY
	<C: #define OFN_HIDEREADONLY 0x00000004
	>!

OFN_LONGNAMES
	<C: #define OFN_LONGNAMES 0x00200000
	>!

OFN_NOCHANGEDIR
	<C: #define OFN_NOCHANGEDIR 0x00000008
	>!

OFN_NODEREFERENCELINKS
	<C: #define OFN_NODEREFERENCELINKS 0x00100000
	>!

OFN_NOLONGNAMES
	<C: #define OFN_NOLONGNAMES 0x00040000
	>!

OFN_NONETWORKBUTTON
	<C: #define OFN_NONETWORKBUTTON 0x00020000
	>!

OFN_NOREADONLYRETURN
	<C: #define OFN_NOREADONLYRETURN 0x00008000
	>!

OFN_NOTESTFILECREATE
	<C: #define OFN_NOTESTFILECREATE 0x00010000
	>!

OFN_NOVALIDATE
	<C: #define OFN_NOVALIDATE 0x00000100
	>!

OFN_OVERWRITEPROMPT
	<C: #define OFN_OVERWRITEPROMPT 0x00000002
	>!

OFN_PATHMUSTEXIST
	<C: #define OFN_PATHMUSTEXIST 0x00000800
	>!

OFN_READONLY
	<C: #define OFN_READONLY 0x00000001
	>!

OFN_SHAREAWARE
	<C: #define OFN_SHAREAWARE 0x00004000
	>!

OFN_SHAREFALLTHROUGH
	<C: #define OFN_SHAREFALLTHROUGH 2
	>!

OFN_SHARENOWARN
	<C: #define OFN_SHARENOWARN 1
	>!

OFN_SHAREWARN
	<C: #define OFN_SHAREWARN 0
	>!

OFN_SHOWHELP
	<C: #define OFN_SHOWHELP 0x00000010
	>! !

!Win32CommonDialogs methodsFor: 'procedures'!

GetOpenFileNameA: arg
	<C: BOOL GetOpenFileNameA(LPOPENFILENAMEA)>
	^self externalAccessFailed!

GetOpenFileNameW: arg
	<C: BOOL GetOpenFileNameW(LPOPENFILENAMEW)>
	^self externalAccessFailed!

GetSaveFileNameA: arg
	<C: BOOL GetSaveFileNameA(LPOPENFILENAMEA)>
	^self externalAccessFailed!

GetSaveFileNameW: arg
	<C: BOOL GetSaveFileNameW(LPOPENFILENAMEW)>
	^self externalAccessFailed! !

Object subclass: #FileDialogInterface
	instanceVariableNames: 'fileFilter filterIndex fileName initialDirectory titleBarText flags defaultExtension returnedFilePath options '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Windows-External Applications'!


!FileDialogInterface methodsFor: 'translation'!

customFilterIndexTranslated
	^0!

customFilterTranslated
	^String new copyToHeap!

defaultExtensionTranslated
	^self defaultExtension isNil
		ifTrue: [ String new copyToHeap ]
		ifFalse: [ self defaultExtension copyToHeap ]!

fileExtensionTranslated

	^0!

fileFilterTranslated
	"The fileFilter ivar contains an OrderedCollection of associations.
		DLLCC needs a single string, with each section null-terminated.
		A double null signals the end.  Build and return it."
	| str null |
	self fileFilter isNil ifTrue: [ ^String new copyToHeap ] .
	null := Character value: 0 .
	str := WriteStream on: String new .
	fileFilter do: [ :anAssociation |
		str nextPutAll: anAssociation key ;
			nextPut: null ;
			nextPutAll: anAssociation value ;
			nextPut: null  ] .
	str nextPut: null .
	^str contents copyToHeap!

fileNameTranslated

	| buf |
	buf := String new: 300 .
	self fileName isNil
		ifTrue: [ buf at: 1 put: (Character value: 0) ]
		ifFalse:[ buf replaceFrom: 1 to: self fileName size with: self fileName ] .
	^buf copyToHeap!

fileOffsetExtensionTranslated

	^0!

fileOffsetTranslated

	^0!

fileTitleTranslated

	^(String new: 100) copyToHeap!

filterIndexTranslated
	self fileFilter isNil ifTrue: [ ^0 ] .
	self filterIndex isNil ifTrue: [ filterIndex := 0 ] .
	^self filterIndex > self fileFilter size
		ifTrue: [ 0 min: self fileFilter size ]
		ifFalse: [ self filterIndex ]!

initialDirectoryTranslated
	^self initialDirectory isNil
		ifTrue: [ String new copyToHeap ]
		ifFalse: [ self initialDirectory copyToHeap ]!

maxFileNameTranslated

	^300!

maxFileTitleTranslated

	^100!

optionsTranslatedFrom: anInterfaceClass
	| lookup cntr |
	lookup := self flagTranslationDictionaryFrom: anInterfaceClass . 
	cntr := 0 .
	self options keysAndValuesDo:
		[ :k :v | 
			v ifTrue: [ cntr := cntr + (lookup at: k) ] ] .
	^cntr!

structureSizeTranslated
	^76!

titleBarTextTranslated
	^self titleBarText isNil
		ifTrue: [ String new copyToHeap ]
		ifFalse: [ self titleBarText copyToHeap ]!

windowOwnerTranslated
	^WindowsUserDLL new GetActiveWindow! !

!FileDialogInterface methodsFor: 'accessing'!

defaultExtension

	^defaultExtension!

defaultExtension: aValue

	defaultExtension := aValue!

fileFilter
	^fileFilter!

fileFilter: anOC
	fileFilter := anOC!

fileName
	^fileName!

fileName: aString
	fileName := aString!

filterIndex

	^filterIndex!

filterIndex: aValue
	filterIndex := aValue!

initialDirectory
	^initialDirectory!

initialDirectory: aString
	initialDirectory := aString!

returnedFilePath
	^returnedFilePath!

titleBarText

	^titleBarText!

titleBarText: aValue

	titleBarText := aValue! !

!FileDialogInterface methodsFor: 'running'!

freeAllMemoryIn: aStruct
	| oc |
	oc := #( #lpstrFilter #lpstrCustomFilter #lpstrFile #lpstrFileTitle #lpstrInitialDir #lpstrTitle #lpstrDefExt) .
	oc do: [ :each | (aStruct memberAt: each) freePointer ]!

openFileDialog
	| struct class res | 
	class :=  Win32CommonDialogs new .
	struct := self structureIn: class .
	res := class GetOpenFileNameA: struct .
	res = 1 ifTrue: [returnedFilePath := (struct memberAt: #lpstrFile) copyCStringFromHeap] .
	self freeAllMemoryIn: struct .
	^res = 1!

saveFileDialog
	| struct class res | 
	class :=  Win32CommonDialogs new . 
	struct := self structureIn: class .
	res := class GetSaveFileNameA: struct .
	res = 1 ifTrue: [returnedFilePath := (struct memberAt: #lpstrFile) copyCStringFromHeap] .
	self freeAllMemoryIn: struct .
	^res = 1! !

!FileDialogInterface methodsFor: 'options'!

addOption: aSymbol
	(self options includesKey: aSymbol)
		ifFalse: [ self error: aSymbol, ' is not a valid option.' ] .
	self options at: aSymbol put: true!

options
	options isNil ifTrue: [ self initializeOptions ] .
	^options!

removeOption: aSymbol
	(self options includesKey: aSymbol)
		ifFalse: [ self error: aSymbol, ' is not a valid option.' ] .
	self options at: aSymbol put: false! !

!FileDialogInterface methodsFor: 'private'!

flagTranslationDictionaryFrom: anInterfaceClass
	^IdentityDictionary new
		at: #allowMultiSelect put: anInterfaceClass OFN_ALLOWMULTISELECT ;
		at: #createPrompt put: anInterfaceClass OFN_CREATEPROMPT ;
		at: #enableHook put: anInterfaceClass OFN_ENABLEHOOK ;
		at: #enableTemplate put: anInterfaceClass OFN_ENABLETEMPLATE ;
		at: #enableTemplateHandle put: anInterfaceClass OFN_ENABLETEMPLATEHANDLE ;
		at: #explorer put: anInterfaceClass OFN_EXPLORER ;
		at: #extensionDifferent put: anInterfaceClass OFN_EXTENSIONDIFFERENT ;
		at: #fileMustExist put: anInterfaceClass OFN_FILEMUSTEXIST ;
		at: #hideReadonly put: anInterfaceClass OFN_HIDEREADONLY ;
		at: #longNames put: anInterfaceClass OFN_LONGNAMES ;
		at: #noChangeDir put: anInterfaceClass OFN_NOCHANGEDIR ;
		at: #noLongNames put: anInterfaceClass OFN_NOLONGNAMES ;
		at: #noDereferenceLinks put: anInterfaceClass OFN_NODEREFERENCELINKS ;
		at: #noNetworkButton put: anInterfaceClass OFN_NONETWORKBUTTON ;
		at: #noReadonlyReturn put: anInterfaceClass OFN_NOREADONLYRETURN ;
		at: #noTestFileCreate put: anInterfaceClass OFN_NOTESTFILECREATE ;
		at: #noValidate put: anInterfaceClass OFN_NOVALIDATE ;
		at: #overwritePrompt put: anInterfaceClass OFN_OVERWRITEPROMPT ;
		at: #readonly put: anInterfaceClass OFN_READONLY ;
		at: #shareAware put: anInterfaceClass OFN_SHAREAWARE ;
		at: #shareFallThrough put: anInterfaceClass OFN_SHAREFALLTHROUGH ;
		at: #shareNoWarn put: anInterfaceClass OFN_SHARENOWARN ;
		at: #shareWarn put: anInterfaceClass OFN_SHAREWARN ;
		at: #showHelp put: anInterfaceClass OFN_SHOWHELP ;
		yourself!

initializeOptions
	options := IdentityDictionary new 
		at: #allowMultiSelect put: false ;
		at: #createPrompt put: false ;
		at: #enableHook put: false ;
		at: #enableTemplate put: false ;
		at: #enableTemplateHandle put: false ;
		at: #explorer put: false ;
		at: #extensionDifferent put: false ;
		at: #fileMustExist put: false ;
		at: #hideReadonly put: false ;
		at: #longNames put: false ;
		at: #noChangeDir put: false ;
		at: #noReadonlyReturn put: false ;
		at: #noTestFileCreate put: false ;
		at: #noValidate put: false ;
		at: #noLongNames put: false ;
		at: #noNetworkButton put: false ;
		at: #overwritePrompt put: false ;
		at: #readonly put: false ;
		at: #shareAware put: false ;
		at: #shareFallThrough put: false ;
		at: #shareNoWarn put: false ;
		at: #shareWarn put: false ;
		at: #showHelp put: false ;
		yourself!

structureIn: interfaceClass
	| struct |
	struct := interfaceClass OPENFILENAMEA malloc . 
	struct memberAt: #Flags put: (self optionsTranslatedFrom: interfaceClass) .
	struct memberAt: #hwndOwner put: self windowOwnerTranslated .
	struct memberAt: #lStructSize  put: self structureSizeTranslated .
	struct memberAt: #lpstrFilter put: self fileFilterTranslated .
	struct memberAt: #lpstrCustomFilter put: self customFilterTranslated .
	struct memberAt: #nMaxCustFilter put: self customFilterIndexTranslated .
	struct memberAt: #nFilterIndex put: self filterIndexTranslated .
	struct memberAt: #lpstrFile put: self fileNameTranslated .
	struct memberAt: #nMaxFile put: self maxFileNameTranslated .
	struct memberAt: #lpstrFileTitle put: self fileTitleTranslated .
	struct memberAt: #nMaxFileTitle put: self maxFileTitleTranslated .
	struct memberAt: #lpstrInitialDir put: self initialDirectoryTranslated .
	struct memberAt: #lpstrTitle put: self titleBarTextTranslated .
	struct memberAt: #lpstrDefExt put: self defaultExtensionTranslated .
	^struct! !

ApplicationModel subclass: #FileDialogEditor
	instanceVariableNames: 'uiText uiMenu filename '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Windows-External Applications'!


!FileDialogEditor methodsFor: 'actions'!

fileInAll
	(ReadStream on: self uiText value string) fileIn!

fileItIn: allText from: aController
	| selection |
	selection := aController selection .
	(ReadStream on: selection from: 1 to: selection size) fileIn!

readFile
	| fn dl arr |
	dl := FileDialogInterface new .
	arr := Array with: 'Smalltalk Files {*.st}' -> '*.st' 
		with: 'Change Logs {*.cha}' -> '*.cha' 
		with: 'Text Files {*.txt}' -> '*.txt' 
		with: 'All Files {*.*}' -> '*.*' .
	dl fileFilter: arr .
	dl addOption: #hideReadonly ;
		addOption: #noChangeDir ;
		addOption: #fileMustExist .
	dl titleBarText: 'The Smalltalk Report - Open File' .
	dl openFileDialog ifFalse: [ ^nil ] .
	fn := dl returnedFilePath .
	self filename value: fn asFilename .
	Cursor read showWhile:
		[self uiText value: (filename value contentsOfEntireFile) ] .!

saveFileAs
	| fn dl arr str |
	dl := FileDialogInterface new . 
	arr := Array with: 'Text Files {*.txt}' -> '*.txt' 
			with: 'All files {*.*}' -> '*.*' .
	dl fileFilter: arr .
	self filename value size > 0
	ifTrue: [ dl initialDirectory: self filename value head .
		dl fileName: self filename value tail  ] .
	dl addOption: #hideReadonly ;
		addOption: #noChangeDir  .
	dl defaultExtension: 'st' . 
	dl titleBarText: 'The Smalltalk Report - Save File' .
	dl saveFileDialog ifFalse: [ ^nil ] .
	fn := dl returnedFilePath asFilename .
	self filename value: fn  .
	str := fn writeStream .
	Cursor write showWhile:
		[ str nextPutAll: self uiText value ] .
	str close! !

!FileDialogEditor methodsFor: 'menus'!

uiTextMenu
	^Menu labelList: (ParagraphEditor editGroupLabels,
			#(('file in' 'file in selection') ('read file...' 'save as...') ) )
		values: (ParagraphEditor editGroupSelectors,
			#(#fileInAll #fileItIn:from: #readFile #saveFileAs ) )! !

!FileDialogEditor methodsFor: 'aspects'!

uiText
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^uiText isNil
		ifTrue:
			[uiText := String new asValue]
		ifFalse:
			[uiText]! !

!FileDialogEditor methodsFor: 'change notification'!

filenameChanged
	self builder window label: self filename value tail! !

!FileDialogEditor methodsFor: 'initialize-release'!

initialize
	super initialize .
	self filename onChangeSend: #filenameChanged to: self! !

!FileDialogEditor methodsFor: 'acessing'!

filename
	filename isNil ifTrue: [ filename := String new asValue ] .
	^filename! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

FileDialogEditor class
	instanceVariableNames: ''!


!FileDialogEditor class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: '' 
			#bounds: #(#Rectangle 148 84 479 417 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#TextEditorSpec 
					#layout: #(#LayoutFrame 0 0 0 0 0 1 0 1 ) 
					#name: #uiText 
					#model: #uiText 
					#menu: #uiTextMenu ) ) ) )! !

